/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.util.List;
import storage.StorageManufacturer;
import storage.StorageProduct;
import storage.StorageUser;

/**
 *
 * @author student1
 */
public class Controller {

    private StorageUser storageUser;
    private StorageManufacturer storageManufacturer;
    private StorageProduct storageProduct;
    private static Controller instance;

    private Controller() {
        storageUser = new StorageUser();
        storageManufacturer = new StorageManufacturer();
        storageProduct = new StorageProduct();
    }

    public static Controller getInstance() {
        if (instance == null) {
            instance = new Controller();
        }
        return instance;
    }

    public User login(String username, String password) throws Exception {
        List<User> users = storageUser.getUsers();
        for (User user : users) {
            if (user.getUsername().equals(username) && user.getPassword().equals(password)) {
                return user;
            }
        }
        //return null;
        throw new Exception("Invalid username/password!");
    }

    public List<Manufacturer> getAllManufacturers() {
        return storageManufacturer.getAll();
    }

    public void saveProduct(Product product) {
        Long id = storageProduct.getNextId();
        product.setId(id);
        storageProduct.add(product);
    }

    public List<Product> getAllProducts() {
        return storageProduct.getAll();
    }

}
