/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controler;

import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.util.List;
import storage.StorageManufacturer;
import storage.StorageProduct;
import storage.StorageUser;

/**
 *
 * @author FON
 */
public class Controler {

    private StorageUser storageUser;
    private StorageManufacturer storageManufacturer;
    private StorageProduct storageProduct;
    private static Controler instance;

    private Controler() {
        storageUser = new StorageUser();
        storageManufacturer = new StorageManufacturer();
        storageProduct = new StorageProduct();
    }

    public static Controler getInstance() {
        if (instance == null) {
            instance = new Controler();
        }
        return instance;
    }

    public User logIn(String username, String password) throws Exception {
        List<User> users = storageUser.getUsers();
        for (User user : users) {
            if (user.getUsername().equals(username)) {
                if (user.getPassword().equals(password)) {
                    return user;
                } else {
                    throw new Exception("Pogresna lozinka!");
                }
            }
        }
        throw new Exception("Ne postoji korisnik sa unetim korisnickim imenom!");
    }

    public List<Manufacturer> getAllManufacturers() {
        return storageManufacturer.getAll();
    }

    public void saveProduct(Product product) {
        //setID();
        product.setId(storageProduct.getNextID());
        storageProduct.add(product);
    }

    public List<Product> getAllProducts() {
        return storageProduct.getAll();
    }

    public Product getProduct(Long productId) throws Exception {

        List<Product> products = storageProduct.getAll();
        for (Product product : products) {
            if (product.getId().equals(productId)) {
                return product;
            }
        }
        throw new Exception("Product with id:" + productId + " does not exist!");
    }

    public void updateProduct(Product updatedProduct) throws Exception {
        try {
            List<Product> products = storageProduct.getAll();

            for (Product product : products) {
                if (product.getId().equals(updatedProduct.getId())) {
                    product.setName(updatedProduct.getName());
                    product.setDescription(updatedProduct.getDescription());
                    product.setPrice(updatedProduct.getPrice());
                    product.setMeasurementUnit(updatedProduct.getMeasurementUnit());
                    product.setManufacturer(updatedProduct.getManufacturer());

                    break;
                }
            }
        } catch (Exception e) {
            throw new Exception("Product is not updated!");
        }
    }
}
