/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.product.model;

import domain.Manufacturer;
import domain.MeasurementUnit;
import domain.Product;
import domain.User;
import java.math.BigDecimal;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelProduct extends AbstractTableModel {

    private List<Product> products;
    private String[] header = new String[]{"ID", "Name", "Desc", "Manufacturer", "Unit", "Price", "User"};

    public TableModelProduct(List<Product> products) {
        this.products = products;
    }

    @Override
    public int getRowCount() {
        return products.size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Product product = products.get(rowIndex);
        switch (columnIndex) {
            case 0:
                return product.getId();
            case 1:
                return product.getName();
            case 2:
                return product.getDescription();
            case 3:
                return product.getManufacturer();
            case 4:
                return product.getMeasurementUnit();
            case 5:
                return product.getPrice();
            case 6:
                return product.getSavedUser();
            default:
                return "n/a";
        }
    }

    @Override
    public String getColumnName(int columnIndex) {
        return header[columnIndex];
    }

    public void addRow(Product product) {
        products.add(product);
        fireTableDataChanged();
        System.out.println("Added new product");
    }

    public void removeRow(int rowIndex) {
        products.remove(rowIndex);
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 0 || columnIndex == header.length - 1) {
            return false;
        }
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Product product = products.get(rowIndex);
        switch (columnIndex) {
            case 0:
                product.setId((Long) aValue);
                break;
            case 1:
                product.setName((String) aValue);
                break;
            case 2:
                product.setDescription((String) aValue);
                break;
            case 3:
                product.setManufacturer((Manufacturer) aValue);
                break;
            case 4:
                product.setMeasurementUnit((MeasurementUnit) aValue);
                break;
            case 5:
                product.setPrice(new BigDecimal((String) aValue));
                break;
            case 6:
                product.setSavedUser((User) aValue);
                break;
        }
    }

    public List<Product> getProducts() {
        return products;
    }
}
