/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Product;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;

/**
 *
 * @author student1
 */
public class StorageDatabaseProduct {

    public void add(Product product) throws Exception {
        try {
            Connection connection = DatabaseConnection.getInstance().getConnection();
            String query = "INSERT INTO Product(name, description, measurementUnit, price, manufacturer_id, user_id) VALUES (?,?,?,?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            preparedStatement.setString(1, product.getName());
            preparedStatement.setString(2, product.getDescription());
            preparedStatement.setString(3, product.getMeasurementUnit().toString());
            preparedStatement.setBigDecimal(4, product.getPrice());
            preparedStatement.setLong(5, product.getManufacturer().getId());
            preparedStatement.setLong(6, product.getSavedUser().getId());
            preparedStatement.executeUpdate();
            preparedStatement.close();
        } catch (SQLException ex) {
            throw new Exception(ex.getMessage(), ex);
        }
    }

    public void addProducts(List<Product> products) throws Exception {
        Connection connection = null;
        try {
            connection = DatabaseConnection.getInstance().getConnection();
            String query = "INSERT INTO Product(name, description, measurementUnit, price, manufacturer_id, user_id) VALUES (?,?,?,?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            for (Product product : products) {
                preparedStatement.setString(1, product.getName());
                preparedStatement.setString(2, product.getDescription());
                preparedStatement.setString(3, product.getMeasurementUnit().toString());
                preparedStatement.setBigDecimal(4, product.getPrice());
                preparedStatement.setLong(5, product.getManufacturer().getId());
                preparedStatement.setLong(6, product.getSavedUser().getId());
                preparedStatement.executeUpdate();
            }
            connection.commit();
            preparedStatement.close();
        } catch (SQLException ex) {
            if (connection != null) {
                connection.rollback();
            }
            throw new Exception(ex.getMessage(), ex);
        }
    }

}
