/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.invoice.model;

import domain.Invoice;
import domain.InvoiceItem;
import domain.Product;
import java.math.BigDecimal;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelInvoice extends AbstractTableModel {

    private Invoice invoice;
    private String header[] = new String[]{"Order No.", "Product", "Unit", "Price", "Qunatity", "Total"};

    public TableModelInvoice(Invoice invoice) {
        this.invoice = invoice;
    }

    @Override
    public int getRowCount() {
        return invoice.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public String getColumnName(int rowIndex) {
        return header[rowIndex];
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        InvoiceItem item = invoice.getItems().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return item.getOrderNo();
            case 1:
                return item.getProduct().getName();
            case 2:
                return item.getProduct().getMeasurementUnit();
            case 3:
                return item.getPrice();
            case 4:
                return item.getQuantity();
            case 5:
                return item.getQuantity().multiply(item.getPrice());
            default:
                return "n/a";
        }
    }

    public void addInvoiceItem(Product product, BigDecimal quantity) {
        InvoiceItem item = new InvoiceItem();
        item.setPrice(product.getPrice());
        item.setProduct(product);
        item.setQuantity(quantity);
        item.setOrderNo(invoice.getItems().size() + 1);
        invoice.getItems().add(item);
        fireTableDataChanged();
    }

    public void removeInvoiceItem(int rowIndex) {
        invoice.getItems().remove(rowIndex);
        setOrderNo();
        fireTableDataChanged();
    }

    public Invoice getInvoice() {
        return invoice;
    }

    private void setOrderNo() {
        int orderID = 0;
        for (InvoiceItem item : invoice.getItems()) {
            item.setOrderNo(++orderID);
        }
    }

}
