/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Invoice;
import domain.InvoiceItem;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import storage.AbstractStorageInvoice;
import storage.database.connection.DatabaseConnection;

/**
 *
 * @author student1
 */
public class DatabaseStorageInvoice extends AbstractStorageInvoice {

    @Override
    public Invoice saveInvoice(Invoice invoice) throws Exception {
        Connection connection = null;
        try {
            connection = DatabaseConnection.getInstance().getConnection();
            String sql = "INSERT INTO Invoice(created_date, created_user_id, amount) VALUES (?, ?, ?)";
            PreparedStatement ps = connection.prepareStatement(sql, PreparedStatement.RETURN_GENERATED_KEYS);
            ps.setDate(1, new java.sql.Date(invoice.getCreatedDate().getTime()));
            ps.setLong(2, invoice.getCreatedUser().getId());
            ps.setBigDecimal(3, invoice.getAmount());
            ps.executeUpdate();

            ResultSet rsKeys = ps.getGeneratedKeys();
            long id = 0;
            if (rsKeys.next()) {
                id = rsKeys.getLong(1);
                invoice.setId(id);
            } else {
                throw new Exception("Invalid id!");
            }

            sql = "INSERT INTO Invoice_Item(invoice_id, order_no, product_id, price, quantity) VALUES (?,?,?,?,?)";
            PreparedStatement psItem = connection.prepareStatement(sql);
            for (InvoiceItem item : invoice.getItems()) {
                psItem.setLong(1, id);
                psItem.setInt(2, item.getOrderNo());
                psItem.setLong(3, item.getProduct().getId());
                psItem.setBigDecimal(4, item.getPrice());
                psItem.setBigDecimal(5, item.getQuantity());
                psItem.executeUpdate();
            }
            connection.commit();
            ps.close();
            psItem.close();
            rsKeys.close();
            return invoice;
        } catch (SQLException ex) {
            if (connection != null) {
                connection.rollback();
            }
            throw ex;
        }
    }

}
