/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.invoice.model;

import domain.Invoice;
import domain.InvoiceItem;
import domain.Product;
import java.math.BigDecimal;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelInvoice extends AbstractTableModel {

    private Invoice invoice;
    private String[] header = new String[]{"OrderID", "Product", "Unit", "Price", "Quantity", "Total"};

    public TableModelInvoice(Invoice invoice) {
        this.invoice = invoice;
    }

    @Override
    public int getRowCount() {
        return invoice.getInvoiceItems().size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        InvoiceItem item = invoice.getInvoiceItems().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return item.getOrderNo();
            case 1:
                return item.getProduct().getName();
            case 2:
                return item.getProduct().getMeasurementUnit();
            case 3:
                return item.getPrice();
            case 4:
                return item.getQuantity();
            case 5:
                return (item.getPrice().multiply(item.getQuantity()));
            default:
                return "n/a";
        }
    }

    @Override
    public String getColumnName(int columnIndex) {
        return header[columnIndex];
    }

    public Invoice getInvoice() {
        return invoice;
    }

    public void addItem(Product product, BigDecimal qunatity) {
        InvoiceItem item = new InvoiceItem();
        item.setPrice(product.getPrice());
        item.setProduct(product);
        item.setQuantity(qunatity);
        item.setOrderNo(invoice.getInvoiceItems().size() + 1);
        invoice.getInvoiceItems().add(item);
        fireTableDataChanged();
    }

    public void removeItem(int rowIndex) {
        invoice.getInvoiceItems().remove(rowIndex);
        calucalteOrderId();
        fireTableDataChanged();
    }

    private void calucalteOrderId() {
        int orderId = 0;
        for (InvoiceItem item : invoice.getInvoiceItems()) {
            orderId++;
            item.setOrderNo(orderId);
        }
    }

}
