/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Invoice;
import domain.InvoiceItem;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import storage.AbstractStorageInvoice;
import storage.database.connection.DatabaseConnection;

/**
 *
 * @author student1
 */
public class DatabaseStorageInvoice extends AbstractStorageInvoice {

    @Override
    public Invoice saveInvoice(Invoice invoice) throws Exception {
        Connection connection = null;
        try {
            connection = DatabaseConnection.getInstance().getConnection();
            String query = "INSERT INTO invoice(created_date, created_user_id, amount) VALUES (?,?,?)";
            PreparedStatement psInvoice = connection.prepareStatement(query, Statement.RETURN_GENERATED_KEYS);
            psInvoice.setDate(1, new java.sql.Date(invoice.getCreatedDate().getTime()));
            psInvoice.setLong(2, invoice.getCreatedUser().getId());
            psInvoice.setBigDecimal(3, invoice.getAmount());
            psInvoice.executeUpdate();
            ResultSet rsKeys = psInvoice.getGeneratedKeys();
            long invoiceID = 0;
            if (rsKeys.next()) {
                invoiceID = rsKeys.getLong(1);
                invoice.setId(invoiceID);
            } else {
                throw new Exception("Invalid query!");
            }

            query = "INSERT INTO invoice_item(invoice_id, order_no, product_id, price, quantity) VALUES (?,?,?,?,?)";
            int orderNo = 0;
            PreparedStatement psItem = connection.prepareStatement(query);
            for (InvoiceItem item : invoice.getInvoiceItems()) {
                item.setInvoiceID(invoiceID);
                psItem.setLong(1, invoice.getId());
                psItem.setInt(2, ++orderNo);
                psItem.setLong(3, item.getProduct().getId());
                psItem.setBigDecimal(4, item.getPrice());
                psItem.setBigDecimal(5, item.getQuantity());
                psItem.executeUpdate();
            }
            connection.commit();
            psItem.close();
            psInvoice.close();
            return invoice;
        } catch (SQLException ex) {
            ex.printStackTrace();
            if (connection != null) {
                connection.rollback();
            }
            throw ex;
        }
    }

}
