/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package start;

import controler.Controler;
import domain.Manufacturer;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import transfer.Request;
import transfer.Response;
import transfer.util.Operation;
import transfer.util.ResponseStatus;

/**
 *
 * @author student1
 */
public class Start {

    private Socket socket;
    private boolean active = true;

    public void startServer() throws IOException, ClassNotFoundException {
        ServerSocket ss = new ServerSocket(9000);
        System.out.println("Server is up and running.");
        socket = ss.accept();
        System.out.println("Client accepted.");
        handleRequest();
    }

    private void handleRequest() throws IOException, ClassNotFoundException {
        while (active) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            Request request = (Request) inSocket.readObject();
            Response response = new Response();
            int operation = request.getOperation();
            System.out.println("Operation: " + operation);
            try {
                switch (operation) {
                    case Operation.OPERATION_LOGIN:
                        User requestUser = (User) request.getData();
                        User user = Controler.getInstance().logIn(requestUser.getUsername(), requestUser.getPassword());
                        response.setStatus(ResponseStatus.OK);
                        response.setData(user);
                        break;
                    case Operation.OPERATION_GET_MANUFACTURERS:
                        List<Manufacturer> manufacturers = Controler.getInstance().getAllManufacturers();
                        response.setStatus(ResponseStatus.OK);
                        response.setData(manufacturers);
                        break;
                }
            } catch (Exception ex) {
                ex.printStackTrace();
                response.setStatus(ResponseStatus.ERROR);
                response.setError(ex);
            }
            sendResponse(response);
        }
    }

    private void sendResponse(Response response) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(response);
    }

    public static void main(String[] args) throws IOException, ClassNotFoundException {
        //Start start = new Start();
        //start.startServer();
        new Start().startServer();
    }

}
