/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controler;

import domain.GeneralEntity;
import domain.Invoice;
import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.sql.SQLException;
import java.util.List;
import storage.IDatabaseBroker;
import storage.StorageInvoice;
import storage.StorageManufacturer;
import storage.StorageProduct;
import storage.StorageUser;
import storage.database.DatabaseBroker;
import storage.database.DatabaseStorageInvoice;
import storage.database.DatabaseStorageManufacturer;
import storage.database.DatabaseStorageProduct;
import storage.database.DatabaseStorageUser;

public class Controler {

    private static Controler instance;

    private final StorageUser storageUser;
    private final StorageManufacturer storageManufacturer;
    private final StorageProduct storageProduct;
    private final StorageInvoice storageInvoice;
    private final IDatabaseBroker databaseBroker;

    private Controler() {
        storageUser = new DatabaseStorageUser();
        storageManufacturer = new DatabaseStorageManufacturer();
        storageProduct = new DatabaseStorageProduct();
        storageInvoice = new DatabaseStorageInvoice();
        databaseBroker = new DatabaseBroker();
    }

    public static Controler getInstance() {
        if (instance == null) {
            instance = new Controler();
        }
        return instance;
    }

    public User logIn(String username, String password) throws Exception {
        return storageUser.findByUsernameAndPassword(username, password);
    }

    public List<GeneralEntity> getAllManufacturers() throws Exception {
        return databaseBroker.getAll(new Manufacturer());
    }

    public void saveProduct(Product product) throws SQLException {
        storageProduct.add(product);
    }

    public void saveProducts(List<Product> products) throws Exception {
        ((DatabaseStorageProduct) storageProduct).addAll(products);
    }

    public List<Product> getAllProducts() throws Exception {
        return storageProduct.getAll();
    }

    public Product getProduct(Long productId) throws Exception {
        return storageProduct.findById(productId);
    }

    public void updateProduct(Product updatedProduct) throws Exception {
    }

    public Invoice saveInvoice(Invoice invoice) throws Exception {
        return storageInvoice.saveInvoice(invoice);
    }
}
