/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package thread;

import controler.Controler;
import domain.GeneralEntity;
import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import transfer.Request;
import transfer.Response;
import transfer.util.Operation;
import transfer.util.ResponseStatus;

/**
 *
 * @author student1
 */
public class ClientThread extends Thread {

    private Socket socket;

    public ClientThread(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        try {
            handleRequest();
        } catch (IOException ex) {
            Logger.getLogger(ClientThread.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(ClientThread.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void handleRequest() throws IOException, ClassNotFoundException {
        while (!isInterrupted()) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            Request request = (Request) inSocket.readObject();
            Response response = new Response();
            try {
                int operation = request.getOperation();
                System.out.println("Operation: " + operation);
                switch (operation) {
                    case Operation.OPERATION_LOGIN:
                        User dataUser = (User) request.getData();
                        User user = Controler.getInstance().logIn(dataUser.getUsername(), dataUser.getPassword());
                        response.setStatus(ResponseStatus.OK);
                        response.setData(user);
                        break;
                    case Operation.OPERATION_GET_ALL_MANUFACTURERS:
                        List<GeneralEntity> manufacturers = Controler.getInstance().getAllManufacturers();
                        response.setStatus(ResponseStatus.OK);
                        response.setData(manufacturers);
                        break;
                    case Operation.OPERATION_GET_ALL_PRODUCTS:
                        List<Product> products = Controler.getInstance().getAllProducts();
                        response.setStatus(ResponseStatus.OK);
                        response.setData(products);
                }

            } catch (Exception ex) {
                ex.printStackTrace();
                response.setStatus(ResponseStatus.ERROR);
                response.setError(ex);
            }
            sendResponse(response);
        }
    }

    private void sendResponse(Response response) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(response);
    }

}
