/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.sql.SQLException;
import java.util.List;
import session.Session;
import transfer.Request;
import transfer.Response;
import transfer.util.Operation;
import transfer.util.ResponseStatus;

public class Controller {

    private static Controller instance;

    private Controller() {
    }

    public static Controller getInstance() {
        if (instance == null) {
            instance = new Controller();
        }
        return instance;
    }

    public User logIn(String username, String password) throws Exception {
        Request request = new Request();
        request.setOperation(Operation.OPERATION_LOGIN);
        request.setData(new User(null, username, password, null, null, null));
        ObjectOutputStream outSocket = new ObjectOutputStream(
                Session.getInstance()
                        .getSocket()
                        .getOutputStream());
        outSocket.writeObject(request);
        ObjectInputStream inSocket = new ObjectInputStream(
                Session.getInstance().getSocket().getInputStream());
        Response response = (Response) inSocket.readObject();
        if(response.getStatus() == ResponseStatus.SUCCESS) {
            return (User) response.getData();
        } else {
            throw (Exception) response.getError();
        }
    }

    public List<Manufacturer> getAllManufacturers() throws Exception {
        Request request = new Request();
        request.setOperation(Operation.OPERATION_GET_ALL_MANUFACTURERS);
        ObjectOutputStream outSocket = new ObjectOutputStream(
                Session.getInstance()
                        .getSocket()
                        .getOutputStream());
        outSocket.writeObject(request);
        ObjectInputStream inSocket = new ObjectInputStream(
                Session.getInstance().getSocket().getInputStream());
        Response response = (Response) inSocket.readObject();
        if(response.getStatus() == ResponseStatus.SUCCESS) {
            return (List<Manufacturer>) response.getData();
        } else {
            throw (Exception) response.getError();
        }
    }

    public void saveProduct(Product product) throws SQLException {
    }

    public void saveProducts(List<Product> products) throws Exception {
    }

    public List<Product> getAllProducts() throws Exception {
        return null;
    }

    public Product getProduct(Long productId) throws Exception {
        return null;
    }

    public void updateProduct(Product updatedProduct) throws Exception {
    }
}
