/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.product.model;

import domain.Manufacturer;
import domain.MeasurementUnit;
import domain.Product;
import domain.User;
import java.math.BigDecimal;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelProduct extends AbstractTableModel{
    private List<Product> products;
    private String[] header=new String[]{"ID","Name","Description","Manufacturer", "Unit", "Price", "User"};

    public TableModelProduct(List<Product> products) {
        this.products = products;
    }

    @Override
    public String getColumnName(int i) {
        return header[i];
    }

    @Override
    public int getRowCount() {
        if(products==null){
            return 0;
        }
        return products.size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Product product=products.get(rowIndex);
        switch (columnIndex){
            case 0: 
                return product.getId();
            case 1: 
                return product.getName();
            case 2:
                return product.getDescription();
            case 3: 
                return product.getManufacturer();
            case 4:
                return product.getMeasurementUnit();
            case 5:
                return product.getPrice();
            case 6: 
                return product.getSavedUser();
            default:
                return "N/A";
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        switch(columnIndex){
            case 0: return false;
            case 1: return true;
            case 2: return true;
            case 3: return true;
            case 4: return true;
            case 5: return true;
            case 6: return false;
            default: return false;
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Product product=products.get(rowIndex);
        switch(columnIndex){
            case 0: 
                product.setId((Long)aValue);
                break;
            case 1:
                product.setName(aValue.toString());
                break;
            case 2:
                product.setDescription(aValue.toString());
                break;
            case 3:
                product.setManufacturer((Manufacturer)aValue);
                break;
            case 4:
                product.setMeasurementUnit(MeasurementUnit.valueOf(aValue.toString()));
                break;
            case 5:
                product.setPrice(new BigDecimal(aValue.toString()));
                break;
            case 6: 
                product.setSavedUser((User)aValue);
                break;
        }
    }
    
    public void addProduct(Product product){
        products.add(product);
        fireTableDataChanged();
    }
    
    public void removeProduct(int rowIndex){
        products.remove(rowIndex);
        fireTableDataChanged();
    }
    
    public List<Product> getProducts(){
        return products;
    }
    
}
