/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.invoice.model;

import domain.Invoice;
import domain.InvoiceItem;
import domain.Product;
import java.math.BigDecimal;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelInvoice extends AbstractTableModel {

    private Invoice invoice;
    String[] header = new String[]{"order", "product", "price", "quantity"};

    public TableModelInvoice(Invoice invoice) {
        this.invoice = invoice;
    }

    @Override
    public int getRowCount() {
        return invoice == null ? 0 : invoice.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int row, int column) {
        InvoiceItem item = invoice.getItems().get(row);
        switch (column) {
            case 0:
                return item.getOrderNo();
            case 1:
                return item.getProduct().getName();
            case 2:
                return item.getPrice();
            case 3:
                return item.getQuantity();
            default:
                return "N/A";
        }
    }

    @Override
    public String getColumnName(int column) {
        return header[column];
    }

    public void addRow(Product product, BigDecimal quantity) {
        InvoiceItem item = new InvoiceItem();
        item.setInvoice(invoice);
        item.setOrderNo(invoice.getItems().size()+1);
        item.setPrice(product.getPrice());
        item.setProduct(product);
        item.setQuantity(quantity);
        
        invoice.getItems().add(item);
        fireTableDataChanged();
    }

    public Invoice getData() {
        return invoice;
    }

}
