/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.product.model;

import domain.Product;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelProduct extends AbstractTableModel {

    private final List<Product> products;
    String[] header = new String[]{"id", "name", "manufacturer", "unit", "price", "user"};

    public TableModelProduct(List<Product> products) {
        this.products = products;
    }

    @Override
    public int getRowCount() {
        return products == null ? 0 : products.size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int row, int column) {
        Product product = products.get(row);
        switch (column) {
            case 0: return product.getId();
            case 1: return product.getName();
            case 2: return product.getManufacturer();
            case 3: return product.getMeasurementUnit();
            case 4: return product.getPrice();
            case 5: return product.getSavedUser();
            default: return "N/A";
        }
    }

    @Override
    public String getColumnName(int column) {
        return header[column];
    }

    public Product getRow(int selectedRow) {
        return products.get(selectedRow);
    }
    
    

}
