/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Invoice;
import domain.InvoiceItem;
import java.math.BigDecimal;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import storage.AbstractStorageInvoice;
import storage.database.connection.DatabaseConnection;

/**
 *
 * @author student1
 */
public class DatabaseStorageInvoice extends AbstractStorageInvoice {

    @Override
    public void add(Invoice invoice) {
        try {
            //sacuvaj racun
            String querySaveInvoice = "INSERT INTO invoice (created_date,created_user_id,amount)"
                    + " VALUES (?,?,?)";
            PreparedStatement ps = DatabaseConnection.getInstance().getConnection()
                    .prepareStatement(querySaveInvoice, PreparedStatement.RETURN_GENERATED_KEYS);
            ps.setDate(1, new Date(invoice.getCreatedDate().getTime()));
            ps.setLong(2, invoice.getCreatedUser().getId());
            ps.setBigDecimal(3, invoice.getAmount());
            System.out.println(ps.toString());
            ps.executeUpdate();
            ResultSet rs = ps.getGeneratedKeys();
            if (rs != null && rs.next()) {
                long invoiceId = rs.getLong(1);
                System.out.println("Invoice id: " + invoiceId);
                String querySaveItems = "INSERT INTO invoice_item"
                        + " (invoice_id,order_no,product_id,price,quantity)"
                        + " VALUES (?,?,?,?,?)";
                PreparedStatement prS = DatabaseConnection.getInstance().getConnection().prepareStatement(querySaveItems);
                for (InvoiceItem item : invoice.getItems()) {
                    prS.setLong(1,invoiceId);
                    prS.setInt(2,item.getOrderNo());
                    prS.setLong(3,item.getProduct().getId());
                    prS.setBigDecimal(4, item.getPrice());
                    prS.setBigDecimal(5, item.getQuantity());
                    prS.executeUpdate();
                }
                DatabaseConnection.getInstance().getConnection().commit();
            }
            //vidi koji je ID racuna
            //sacuvaj stavku
            //potvrdi (ili ponisti) cuvanje racuna 
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseStorageInvoice.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
