/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.invoice.model;

import domain.Invoice;
import domain.InvoiceItem;
import domain.Product;
import java.math.BigDecimal;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelInvoice extends AbstractTableModel {

    private final Invoice invoice;
    private String[] header = new String[]{"No", "Id", "Name", "Price", "Unit", "Quantity"};

    public TableModelInvoice(Invoice i) {
        this.invoice = i;
    }

    @Override
    public int getRowCount() {
        if (invoice == null || invoice.getItems() == null) {
            return 0;
        }
        return invoice.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return header.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        InvoiceItem invoiceItem = invoice.getItems().get(rowIndex);
        switch(columnIndex) {
            case 0: return invoiceItem.getOrderNo();
            case 1: return invoiceItem.getProduct().getId();
            case 2: return invoiceItem.getProduct().getName();
            case 3: return invoiceItem.getProduct().getPrice();
            case 4: return invoiceItem.getProduct().getMeasurementUnit();
            case 5: return invoiceItem.getQuantity();
            default: return "N/A";
        }
    }

    @Override
    public String getColumnName(int i) {
        return header[i];
    }

    public void addItem(Product product, BigDecimal quantity) {
        // TODO ako proizvod postoji u racunu povecaj kolicinu
        InvoiceItem invoiceItem = new InvoiceItem();
        invoiceItem.setInvoice(invoice);
        invoiceItem.setOrderNo(invoice.getItems().size() + 1);
        invoiceItem.setProduct(product);
        invoiceItem.setPrice(product.getPrice());
        invoiceItem.setQuantity(quantity);
        invoice.getItems().add(invoiceItem);
        fireTableDataChanged();
    }
    
    

}
