/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package thread;

import com.sun.xml.internal.ws.fault.ServerSOAPFaultException;
import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import transfer.Operation;
import transfer.Response;

/**
 *
 * @author student1
 */
public class ServerThread extends Thread{

    private ServerSocket serverSocket;
    private List<Thread> usersThread;
    public ServerThread(int port) throws IOException {
        serverSocket=new ServerSocket(port);
        usersThread=new LinkedList<>();
    }

    @Override
    public void run() {
        while(!isInterrupted()){
            try {
                System.out.println("Waiting for new client");
                Socket socket=serverSocket.accept();
                System.out.println("Client connected");
                Thread client=new ClientThread(socket);
                client.start();
                usersThread.add(client);
                //Posalji svima poruku da se novi klijent povezao sa serverom
                sendMessageToAll();
            } catch (IOException ex) {
                Logger.getLogger(ServerThread.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    private void sendMessageToAll() {
        List<String> users=new ArrayList<>();
        
        for(Thread th:usersThread){
            ClientThread clientThread=(ClientThread)th;
            users.add(clientThread.getUsername());
        }
        Response response=new Response(Operation.OPERATION_UPDATE_USERS, users);
        for(Thread th:usersThread){
            try {
                ObjectOutputStream outSocket=new ObjectOutputStream(((ClientThread)th).getSocket().getOutputStream());
                outSocket.writeObject(response);
            } catch (IOException ex) {
                Logger.getLogger(ServerThread.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
}
