/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form.product;

import controler.Controler;
import domain.Product;
import form.FrmMode;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import session.Session;
import usecase.UseCase;

/**
 *
 * @author student1
 */
public class FrmSearchProducts extends javax.swing.JDialog {

    /**
     * Creates new form FrmSearchProducts
     */
    public FrmSearchProducts(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        populateTblProducts();
        adjustForm();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tblProducts = new javax.swing.JTable();
        btnDetails = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Search products");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        tblProducts.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "Name", "Manufacturer", "Price", "Measurement Unit"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblProducts.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblProductsMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(tblProducts);

        btnDetails.setText("Details");
        btnDetails.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDetailsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnDetails)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 970, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 318, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnDetails)
                .addContainerGap(32, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnDetailsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDetailsActionPerformed
        try {
            int selectedRow = getSelectedRow();

            Long productId = (Long) tblProducts.getValueAt(selectedRow, 0);

            JOptionPane.showMessageDialog(this, "Product id:" + productId, "Selected product", JOptionPane.INFORMATION_MESSAGE);

            Session.getInstance().setCurrentUseCase(UseCase.UC_VIEW_PRODUCT);
            Session.getInstance().getUseCaseParams().clear();
            Session.getInstance().getUseCaseParams().put("productId", productId);

            JDialog frmProduct = new FrmProduct(null, true, FrmMode.VIEW);
            frmProduct.setVisible(true);

        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }//GEN-LAST:event_btnDetailsActionPerformed

    private void tblProductsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblProductsMouseClicked
        btnDetails.setEnabled(true);
    }//GEN-LAST:event_tblProductsMouseClicked

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        populateTblProducts();
        adjustForm();
    }//GEN-LAST:event_formWindowActivated

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnDetails;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tblProducts;
    // End of variables declaration//GEN-END:variables

    private void populateTblProducts() {
        setTblModel();//kreira se novi kako se ne bi dodavale nove vrednosti u tabelu ukoliko u tabeli ima vec nekih vrednosti
        
        List<Product> products = Controler.getInstance().getAllProducts();
        TableModel tm = tblProducts.getModel();

        DefaultTableModel dtm = (DefaultTableModel) tm;
        for (Product product : products) {
            Object[] row = new Object[5];
            row[0] = product.getId();
            row[1] = product.getName();
            row[2] = product.getManufacturer();
            row[3] = product.getPrice();
            row[4] = product.getMeasurementUnit();
            dtm.addRow(row);
        }
    }
    private void setTblModel(){
         tblProducts.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "Name", "Manufacturer", "Price", "Measurement Unit"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
    }

    private void adjustForm() {
        setLocationRelativeTo(null);
        btnDetails.setEnabled(false);
    }

    private int getSelectedRow() throws Exception {
        int selectedRow = tblProducts.getSelectedRow();
        if (selectedRow == -1) {
            throw new Exception("Row is not selected!");
        }
        return selectedRow;
    }
}
