/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Product;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;
import storage.DatabaseConnection;

/**
 *
 * @author student1
 */
public class DatabaseStorageProduct {

    public void add(Product product) throws SQLException {
        Connection connection = null;
        try {
            connection = DatabaseConnection.getInstance().getConnection();
            String query = "insert into product(name, description,"
                    + " manufacturer_id, measurementUnit,user_id, price) values(?,?,?,?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            preparedStatement.setString(1, product.getName());
            preparedStatement.setString(2, product.getDescription());
            preparedStatement.setLong(3, product.getManufacturer().getId());
            preparedStatement.setString(4, product.getMeasurementUnit().toString());
            preparedStatement.setLong(5, product.getSavedUser().getId());
            preparedStatement.setBigDecimal(6, product.getPrice());

            preparedStatement.executeUpdate();
            preparedStatement.close();
            connection.commit();
        } catch (Exception e) {
            if (connection != null) {
                connection.rollback();
            }
            throw e;
        }
    }

    public void addAll(List<Product> products) throws Exception {
        Connection connection = null;
        try {
            connection = DatabaseConnection.getInstance().getConnection();
            String query = "insert into product(name, description,"
                    + " manufacturer_id, measurementUnit,user_id, price) values(?,?,?,?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(query);
            for (Product product : products) {
                preparedStatement.setString(1, product.getName());
                preparedStatement.setString(2, product.getDescription());
                preparedStatement.setLong(3, product.getManufacturer().getId());
                preparedStatement.setString(4, product.getMeasurementUnit().toString());
                preparedStatement.setLong(5, product.getSavedUser().getId());
                preparedStatement.setBigDecimal(6, product.getPrice());

                preparedStatement.executeUpdate();
            }

            preparedStatement.close();
            connection.commit();
        } catch (Exception e) {
            if (connection != null) {
                connection.rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }
}
