/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.database;

import domain.Product;
import java.math.BigDecimal;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import session.Session;
import storage.database.connection.DatabaseConnection;

/**
 *
 * @author student1
 */
public class DatabaseStorageProduct {

    public List<Product> getAll() {
        return new ArrayList<>();
    }

    public void add(Product product) throws SQLException {
        try{
            String query = "insert into product"
                    + "(name, description, measurementunit, price, "
                    + "manufacturer_id, user_id) values(?, ?, ?, ?, ?, ?)";
            PreparedStatement ps = DatabaseConnection.getInstance()
                    .getConnection().prepareStatement(query);

            ps.setString(1, product.getName());
            ps.setString(2, product.getDescription());
            ps.setString(3, product.getMeasurementUnit().toString());
            ps.setBigDecimal(4, product.getPrice());
            ps.setLong(5, product.getManufacturer().getId());
            ps.setLong(6, Session.getInstance().getCurrentUser().getId());
            int updatedRows = ps.executeUpdate();
            ps.close();
            DatabaseConnection.getInstance()
                    .getConnection().commit();
        }catch(Exception e){
            if( DatabaseConnection.getInstance()
                    .getConnection()!=null){
                 DatabaseConnection.getInstance()
                    .getConnection().rollback();
            }
            e.printStackTrace();
            throw e;
        }

    }

    public void addAll(List<Product> products) throws Exception {
        try{
        String query = "insert into product"
                + "(name, description, measurementunit, price, "
                + "manufacturer_id, user_id) values(?, ?, ?, ?, ?, ?)";
        PreparedStatement ps = DatabaseConnection.getInstance()
                .getConnection().prepareStatement(query);
        for (Product product : products) {
            ps.setString(1, product.getName());
            ps.setString(2, product.getDescription());
            ps.setString(3, product.getMeasurementUnit().toString());
            ps.setBigDecimal(4, product.getPrice());
            ps.setLong(5, product.getManufacturer().getId());
            ps.setLong(6, Session.getInstance().getCurrentUser().getId());
            int updatedRows = ps.executeUpdate();
        }

        ps.close();
         DatabaseConnection.getInstance()
                    .getConnection().commit();
        }catch(Exception e){
            if( DatabaseConnection.getInstance()
                    .getConnection()!=null){
                 DatabaseConnection.getInstance()
                    .getConnection().rollback();
            }
            e.printStackTrace();
            throw e;
        }
    }
}
