/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import storage.StorageManufacturer;
import storage.StorageProduct;
import storage.StorageUser;

/**
 *
 * @author student1
 */
public class Controller {

   
    private StorageUser storageUser;
    private StorageProduct storageProduct;
    private StorageManufacturer storageManufacturer;
    private static Controller instance;
    
    private Controller() {
        storageUser = new StorageUser();
        storageProduct = new StorageProduct();
        storageManufacturer = new StorageManufacturer();
    }
    
    public static Controller getInstance() {
        if(instance == null) {
            instance = new Controller();
        }
        return instance;
    }
    
    public User logIn(String username, String password) throws Exception{
        try {
            return storageUser.logIn(username, password);
        } catch (Exception ex) {
            throw ex;
        }
        
    }
    
    public List<Manufacturer> getAllManufacturers() {
        return storageManufacturer.getAll();
    }
    
    public void saveProduct(Product product) {
           product.setId(storageProduct.getNextId());
           storageProduct.add(product);
    }

    public List<Product> getAllProducts() {
        return storageProduct.getAll();
    }
}
